from sklearn.datasets import load_boston
from sklearn.svm import SVR
from sklearn.linear_model import LinearRegression
from sklearn.preprocessing import StandardScaler
from sklearn.metrics import mean_absolute_error,mean_squared_error,explained_variance_score,\
    r2_score,mean_absolute_percentage_error,precision_score,accuracy_score,f1_score
from sklearn.model_selection import train_test_split
import numpy as np
#加载数据集
import pandas as pd
import matplotlib.pyplot as plt
import talib
import math
# x=pd.read_excel("./data/STOCKDATAUSE.xlsx",usecols=list(range(2,31)))

def svr_predict_rbf(x,y):
    # Splitting data sets
    x_train,x_test,y_train,y_test=train_test_split(x,y,test_size=0.2,random_state=10,shuffle=False)
    ss=StandardScaler()
    y_train = np.array(y_train).reshape(-1, 1)
    y_test = np.array(y_test).reshape(-1, 1)
    x_train = ss.fit_transform(x_train)
    x_test = ss.fit_transform(x_test)
    y_train = ss.fit_transform(y_train).ravel()
    y_test = ss.fit_transform(y_test).ravel()
    pre_vo=[]
    label_vo=[]
    #Creating SVR instances
    svr=SVR(C=10, kernel='poly', epsilon=0.2)
    svr=svr.fit(x_train,y_train)
    #predict
    svr_predict=svr.predict(x_test)
    svr_predict=ss.inverse_transform(svr_predict).ravel()
    y_test=ss.inverse_transform(y_test)
    # print("svr_predict:" , svr_predict[0])
    for i in range(len(svr_predict)):
        if i == 0:
            pre_vo.append(svr_predict[i]-3414.4527)
        elif i > 0:
            x=svr_predict[i]-svr_predict[i-1]
            pre_vo.append(x)
    # print(pre_vo)
    # print("y_test:" , y_test)
    for i in range(len(y_test)):
        if i == 0:
            label_vo.append(y_test[i]-3414.4527)
        elif i>0:
            label_vo.append(y_test[i]-y_test[i-1])

    x_test=ss.inverse_transform(x_test)
    #Evaluation results
    mae = mean_absolute_error(y_test, svr_predict)
    mape = mean_absolute_percentage_error(y_test, svr_predict)
    mse = mean_squared_error(y_test, svr_predict)
    rmse = mean_squared_error(y_test, svr_predict)**0.5
    evs = explained_variance_score(y_test, svr_predict)
    r2 = r2_score(y_test, svr_predict)
    TP=0
    FP=0
    TN=0
    FN=0
    for i in range(len(pre_vo)):
        if pre_vo[i]>0:
            if label_vo[i]>0:
                TP+=1
            elif label_vo[i]<0:
                FP+=1
        elif pre_vo[i]<0:
            if label_vo[i]>0:
                FN+=1
            elif label_vo[i]<0:
                TN+=1
    precision = TP / (TP+FP)
    accuracy = (TP+TN)/(len(pre_vo))
    recall = TP/(TP+FN)
    fscore = 2*precision*recall/(precision+recall)
    print("MAE：", mae)
    print("MSE：", mse)
    print("MAPE", mape)
    print("EVS：", evs)
    print("R2：", r2)
    print("RMSE" , rmse)
    print("preision", precision)
    print("accuracy" , accuracy)
    print("fscore" , fscore)
    print("\n")

    return svr_predict,y_test
def svr_predict_poly(x,y):
    # Splitting data sets
    x_train,x_test,y_train,y_test=train_test_split(x,y,test_size=0.2,random_state=10,shuffle=False)
    ss=StandardScaler()
    y_train = np.array(y_train).reshape(-1, 1)
    y_test = np.array(y_test).reshape(-1, 1)
    x_train = ss.fit_transform(x_train)
    x_test = ss.fit_transform(x_test)
    y_train = ss.fit_transform(y_train).ravel()
    y_test = ss.fit_transform(y_test).ravel()
    pre_vo=[]
    label_vo=[]
    #Creating SVR instances
    svr=SVR(C=1, kernel='poly', degree=2,epsilon=0.2)
    svr=svr.fit(x_train,y_train)
    #predict
    svr_predict=svr.predict(x_test)
    svr_predict=ss.inverse_transform(svr_predict).ravel()
    y_test=ss.inverse_transform(y_test)
    # print("svr_predict:" , svr_predict[0])
    for i in range(len(svr_predict)):
        if i == 0:
            pre_vo.append(svr_predict[i]-3414.4527)
        elif i > 0:
            x=svr_predict[i]-svr_predict[i-1]
            pre_vo.append(x)

    for i in range(len(y_test)):
        if i == 0:
            label_vo.append(y_test[i]-3414.4527)
        elif i>0:
            label_vo.append(y_test[i]-y_test[i-1])
    x_test=ss.inverse_transform(x_test)
    #Evaluation results
    mae = mean_absolute_error(y_test, svr_predict)
    mape = mean_absolute_percentage_error(y_test, svr_predict)
    mse = mean_squared_error(y_test, svr_predict)
    rmse = mean_squared_error(y_test, svr_predict)**0.5
    evs = explained_variance_score(y_test, svr_predict)
    r2 = r2_score(y_test, svr_predict)
    TP=0
    FP=0
    TN=0
    FN=0
    for i in range(len(pre_vo)):
        if pre_vo[i]>0:
            if label_vo[i]>0:
                TP+=1
            elif label_vo[i]<0:
                FP+=1
        elif pre_vo[i]<0:
            if label_vo[i]>0:
                FN+=1
            elif label_vo[i]<0:
                TN+=1
    precision = TP / (TP+FP)
    accuracy = (TP+TN)/(len(pre_vo))
    recall = TP/(TP+FN)
    fscore = 2*precision*recall/(precision+recall)

    print("MAE：", mae)
    print("MSE：", mse)
    print("MAPE", mape)
    print("EVS：", evs)
    print("R2：", r2)
    print("RMSE" , rmse)
    print("preision", precision)
    print("accuracy" , accuracy)
    print("fscore" , fscore)
    print("\n")
    # print(svr_predict)
    # print(y_test)
    # plt.figure(i)
    return svr_predict,y_test
x1=pd.read_excel("./data/600519data30.xlsx",usecols=list(range(2,32)))
x2=pd.read_excel("./data/600519data30.xlsx",usecols=list(range(2,23)))
x3=pd.read_excel("./data/600519data30.xlsx",usecols=list(range(2,22)))
y=pd.read_excel("./data/600519data30.xlsx",usecols=[2])
svr_predict_pos,y_test1 = svr_predict_poly(x1,y)
svr_predict_polarity,y_test2 = svr_predict_poly(x2,y)
svr_predict,y_test3 = svr_predict_poly(x3,y)
# svr_predict,y_test3 = svr_predict_poly(x3,y)

plt.plot(y_test1, label='label')
plt.plot(svr_predict_pos, label='predict_POS')
plt.plot(svr_predict_polarity, label='predict_polarity')

plt.legend(('label', 'predict_POS', 'predict_polaraty'), loc = 'lower right')
plt.show()
zhix=[]

for i in range(len(svr_predict_pos)):
    zhi1 = {}
    zhi1.update({"predict_POS": svr_predict_pos[i],"predict_polarity":svr_predict_polarity[i],"predict_ys":svr_predict[i],
                 "label": y_test1[i]})
    zhix.append(zhi1)
pf = pd.DataFrame(zhix)
print(pf)
pf.to_excel('./600519/600519svr.xlsx')



df1 = pd.read_excel("D:/stock_predict_with_LSTM-master/600028/600028stock.xlsx")
df2 = pd.read_excel("D:/stock_predict_with_LSTM-master/600050/600050stock.xlsx")
df3 = pd.read_excel("D:/stock_predict_with_LSTM-master/600104/600104stock.xlsx")
df4 = pd.read_excel("D:/stock_predict_with_LSTM-master/600519/600519stock.xlsx")
def backtest_trend_strategy(ohlc: pd.DataFrame,
                            fast_period: int = 5,
                            slow_period: int = 20,
                            threshold: float = 0.5) -> pd.DataFrame:
    """Quantitative backtesting"""
    # Calculation of indicators
    print(ohlc)

    ohlc["fast_ema"] = talib.EMA(ohlc.label, fast_period)
    ohlc["slow_ema"] = talib.EMA(ohlc.label, slow_period)
    ohlc["pct_diff"] = (ohlc["fast_ema"] / ohlc["slow_ema"] - 1) * 100
    ohlc['volarity_multi1'] = (ohlc['Our Model']/ohlc['label'] - 1)* 100
    ohlc['volarity_attlstm1'] = (ohlc['AttLSTM'] / ohlc['label'] - 1) * 100
    ohlc['volarity_lstmx11'] = (ohlc['LSTM+X1'] / ohlc['label'] - 1) * 100
    ohlc['volarity_lstmx01'] = (ohlc['LSTM+X0'] / ohlc['label'] - 1) * 100
    ohlc['volarity_svrx1'] = (ohlc['SVR+X1'] / ohlc['label'] - 1) * 100
    ohlc['volarity_svrx0'] = (ohlc['SVR+X0'] / ohlc['label'] - 1) * 100

    ohlc['volarity_bilstmx01'] = (ohlc['BiLSTM+X0'] / ohlc['label'] - 1) * 100
    ohlc['volarity_bilstmx02'] = (ohlc['BiLSTM+X1'] / ohlc['label'] - 1) * 100


    ohlc["signal_multi1"] = np.where(ohlc["volarity_multi1"] > threshold, 1, 0)
    ohlc["signal_multi1"] = np.where(ohlc["volarity_multi1"] < -threshold, -1, ohlc["signal_multi1"])

    ohlc["signal_attlstm1"] = np.where(ohlc["volarity_attlstm1"] > threshold, 1, 0)
    ohlc["signal_attlstm1"] = np.where(ohlc["volarity_attlstm1"] < -threshold, -1,
                                     ohlc["signal_attlstm1"])

    ohlc["signal_lstmx11"] = np.where(ohlc["volarity_lstmx11"] > threshold, 1, 0)
    ohlc["signal_lstmx11"] = np.where(ohlc["volarity_lstmx11"] < -threshold, -1,
                                     ohlc["signal_lstmx11"])

    ohlc["signal_lstmx01"] = np.where(ohlc["volarity_lstmx01"] > threshold, 1, 0)
    ohlc["signal_lstmx01"] = np.where(ohlc["volarity_lstmx01"] < -threshold, -1,
                                       ohlc["signal_lstmx01"])

    ohlc["signal_svrx1"] = np.where(ohlc["volarity_svrx1"] > threshold, 1, 0)
    ohlc["signal_svrx1"] = np.where(ohlc["volarity_svrx1"] < -threshold, -1,
                                      ohlc["signal_svrx1"])
    ohlc["signal_svrx0"] = np.where(ohlc["volarity_svrx0"] > threshold, 1, 0)
    ohlc["signal_svrx0"] = np.where(ohlc["volarity_svrx0"] < -threshold, -1,
                                      ohlc["signal_svrx0"])

    ohlc["signal_bilstmx01"] = np.where(ohlc["volarity_bilstmx01"] > threshold, 1, 0)
    ohlc["signal_bilstmx01"] = np.where(ohlc["volarity_bilstmx01"] < -threshold, -1,
                                      ohlc["signal_bilstmx01"])
    ohlc["signal_bilstmx02"] = np.where(ohlc["volarity_bilstmx02"] > threshold, 1, 0)
    ohlc["signal_bilstmx02"] = np.where(ohlc["volarity_bilstmx02"] < -threshold, -1,
                                      ohlc["signal_bilstmx02"])


    # Calculate strategy return
    ohlc["returns"] = np.log(ohlc["label"] / ohlc["label"].shift(1))
    ohlc["strategy_returns"] = ohlc["returns"].cumsum()
    ohlc["strategy_multi1"] = ohlc["signal_multi1"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_multi1"] = ohlc["strategy_multi1"].cumsum()
    ohlc["strategy_attlstm1"] = ohlc["signal_attlstm1"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_attlstm1"] = ohlc["strategy_attlstm1"].cumsum()
    ohlc["strategy_lstmx11"] = ohlc["signal_lstmx11"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_lstmx11"] = ohlc["strategy_lstmx11"].cumsum()
    ohlc["strategy_lstmx01"] = ohlc["signal_lstmx01"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_lstmx01"] = ohlc["strategy_lstmx01"].cumsum()
    ohlc["strategy_svrx1"] = ohlc["signal_svrx1"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_svrx1"] = ohlc["strategy_svrx1"].cumsum()
    ohlc["strategy_svrx0"] = ohlc["signal_svrx0"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_svrx0"] = ohlc["strategy_svrx0"].cumsum()
    ohlc["strategy_bilstmx01"] = ohlc["signal_bilstmx01"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_bilstmx01"] = ohlc["strategy_bilstmx01"].cumsum()
    ohlc["strategy_bilstmx02"] = ohlc["signal_bilstmx02"].shift(1) * ohlc["returns"]
    ohlc["strategy_returns_bilstmx02"] = ohlc["strategy_bilstmx02"].cumsum()

    return ohlc
data1 = backtest_trend_strategy(df1)
data2 = backtest_trend_strategy(df2)
data3 = backtest_trend_strategy(df3)
data4 = backtest_trend_strategy(df4)
# print(data['strategy_returns_svrx0'])
def get_max_withdraw(indexs):#Maximum retracement
    max_withdraw = 0
    max_date_index =0
    last_high = indexs[1]

    for index,current in enumerate(indexs):
        # Iterate over all data
        # print(index)
        # print(current)
        if current>last_high:
            last_high=current
            continue

        if (last_high-current)/(last_high+1)>max_withdraw:
            # When a maximum value is found, its position is saved
            max_withdraw = (last_high-current)/(last_high+1)
            max_date_index=index
    # print(max_withdraw)
    # print(max_date_index)
    return max_withdraw*100,max_date_index # Become a percentage
def get_sharpe(indexs):
    strategy_returns_multi1= indexs['strategy_returns_multi1'].values[-1]
    strategy_returns_attlstm1 = indexs['strategy_returns_attlstm1'].values[-1]
    strategy_returns_lstmx11 = indexs['strategy_returns_lstmx11'].values[-1]
    strategy_returns_lstmx01 = indexs['strategy_returns_lstmx01'].values[-1]
    strategy_returns_svrx1 = indexs['strategy_returns_svrx1'].values[-1]
    strategy_returns_svrx0= indexs['strategy_returns_svrx0'].values[-1]
    strategy_returns_bilstmx01 = indexs['strategy_returns_bilstmx01'].values[-1]
    strategy_returns_bilstmx02 = indexs['strategy_returns_bilstmx02'].values[-1]
    strategy_returns = indexs['strategy_returns'].values[-1]
    returns=indexs['returns'].values[-1]
    bodong0 = indexs['returns'].std()
    bodong1=indexs['strategy_multi1'].std()
    bodong3=indexs['strategy_attlstm1'].std()
    bodong5=indexs['strategy_lstmx11'].std()
    bodong7=indexs['strategy_lstmx01'].std()
    bodong9=indexs['strategy_svrx1'].std()
    bodong10 = indexs['strategy_svrx0'].std()
    bodong11 = indexs['strategy_bilstmx01'].std()
    bodong12 = indexs['strategy_bilstmx02'].std()
    # Sharpe=empyrical.sharpe_ratio(strategy_returns, risk_free=returns, period='daily', annualization=None)
    Sharpe_0 = (strategy_returns / 170 - 0.027 / 170) / bodong0 * math.sqrt(170)
    Sharpe_1 = (strategy_returns_multi1 / 170 - 0.027 / 170) / bodong1 * math.sqrt(170)
    # Sharpe_2 = (strategy_returns_multi2 / 240 - 0.027 / 240) / bodong2 * math.sqrt(240)
    Sharpe_3 = (strategy_returns_attlstm1 / 170 - 0.027 / 170) / bodong3 * math.sqrt(170)
    # Sharpe_4 = (strategy_returns_attlstm3 / 240 - 0.027 / 240) / bodong4 * math.sqrt(240)
    Sharpe_5 = (strategy_returns_lstmx11 / 170 - 0.027 / 170) / bodong5 * math.sqrt(170)
    # Sharpe_6 = (strategy_returns_lstmx12 / 240 - 0.027 / 240) / bodong6 * math.sqrt(240)
    Sharpe_7 = (strategy_returns_lstmx01 / 170 - 0.027 / 170) / bodong7 * math.sqrt(170)
    # Sharpe_8 = (strategy_returns_lstmx02 / 240 - 0.027 / 240) / bodong8 * math.sqrt(240)
    Sharpe_9 = (strategy_returns_svrx1 / 170 - 0.027 / 170) / bodong9 * math.sqrt(170)
    Sharpe_10 = (strategy_returns_svrx0 / 170 - 0.027 / 170) / bodong10 * math.sqrt(170)
    Sharpe_11 = (strategy_returns_bilstmx01 / 170 - 0.027 / 170) / bodong11 * math.sqrt(170)
    Sharpe_12 = (strategy_returns_bilstmx02 / 170 - 0.027 / 170) / bodong12 * math.sqrt(170)

    print("sharp multi=", Sharpe_1)
    print("sharp att=", Sharpe_3)
    print("sharp bilstmx1=", Sharpe_12)
    print("sharp bilstmx0=", Sharpe_11)
    print("sharp lstmx1=", Sharpe_5)
    print("sharp lstmx0=", Sharpe_7)
    print("sharp svrx1=", Sharpe_9)
    print("sharp svrx0=", Sharpe_10)
    print("sharp return=", Sharpe_0)
    # # print("sharp2=", Sharpe_2)
    print('returnmulti=', strategy_returns_multi1)
    print('returnatt=', strategy_returns_attlstm1)
    print('returnbilstmx1=', strategy_returns_bilstmx02)
    # print("sharp8=", Sharpe_3)
    print('returnbilstmx0=', strategy_returns_bilstmx01)
    print('returnlstmx1=', strategy_returns_lstmx11)
    print('returnlstmx0=', strategy_returns_lstmx01)
    print('returnsvrx1=', strategy_returns_svrx1)
    print('returnsvrx0=', strategy_returns_svrx0)
    print('return=', strategy_returns)

get_sharpe(data1)
get_sharpe(data2)
get_sharpe(data3)
get_sharpe(data4)
data1.to_excel('D:/stock_predict_with_LSTM-master/600028/huiceresult.xlsx')
# print(data['strategy_returns_polarity'])
# data.to_excel('huice.xlsx')
fig= plt.figure(figsize=(10,7))
ax1 = fig.add_subplot(111)
# Converting horizontal coordinates to date format using pandas
data4['date'] = pd.to_datetime(data4['Date'])
# data['date'] = data['Date']
# plt.xlabel(data['Date'])
# plt.plot(data['strategy_returns_multi1'], label='returns_multi1',linewidth=3,color='#4B4453')
pl1=ax1.plot(data4['date'],data4['strategy_returns_multi1'], label='Our Model',linewidth=3,color='#ff8696')
# plt.plot(data['strategy_returns_attlstm1'], label='returns_attlstm1',linewidth=3,color='#B0A811')
# plt.plot(data['strategy_returns_attlstm2'], label='returns_attlstm2',linewidth=3,color='#B0A8B9')
pl2=ax1.plot(data4['date'],data4['strategy_returns_attlstm1'], label='AttLSTM+X1',linewidth=3,color='yellow')
pl10=ax1.plot(data4['date'],data4['strategy_returns_bilstmx02'], label='BiLSTM+X1',linewidth=3,color='#413688')
pl9=ax1.plot(data4['date'],data4['strategy_returns_bilstmx01'], label='BiLSTM+X0',linewidth=3,color='#548993')
pl11=ax1.plot(data4['date'],data4['strategy_returns_lstmx11'], label='LSTM+X1',linewidth=3,color='#a00000')
pl6=ax1.plot(data4['date'],data4['strategy_returns_lstmx01'], label='LSTM+X0',linewidth=3,color='#aaad43')
pl3=ax1.plot(data4['date'],data4['strategy_returns_svrx1'], label='SVR+X1',linewidth=3,color='#25A854')
pl4=ax1.plot(data4['date'],data4['strategy_returns_svrx0'], label='SVR+X0',linewidth=3,color='#220457')
pl7=ax1.plot(data4['date'],data4['strategy_returns'], label='Buy&Hold',linewidth=3,color='black')
plt.title('600519 Strategy Return & Daliy Heat')
ax1.set_ylabel("Return")
# ax2=plt.subplot(212)
ax2 = ax1.twinx()
ax2.set_ylabel("Count")
pl8=ax2.bar(data4['date'],data4["count"],linewidth=2,label="count",color='powderblue')
# pl=pl1+pl2+pl3+pl4+pl5+pl6+pl7+pl8
# labs = [l.get_label() for l in pl]
# # plt.plot(data['strategy_returns_svrx0'], label='returns_svrx0',linewidth=3,color='#453329')
# # plt.plot(data['strategy_returns_lstmx02'], label='returns_lstmx02',linewidth=3,color='#B077B9')
plt.xlabel("Trading Days")
ax1.legend(['Our Model','AttLSTM+X1','BiLSTM+X1','BiLSTM+X0','LSTM+X1','LSTM+X0','SVR+X1','SVR+X0','Buy&Hold'], loc = 'upper left')
ax2.legend(('Count',
           ), loc = 'upper right')
#

plt.show()
scatter_fig = ax1.get_figure()
scatter_fig.savefig('D:/600519huice.png', dpi=600)
#ourmodel 8/10
#attlstm  1/4/5
#lstmx1   3/5
#lstmx0    6/9